"""
web2ldap plugin classes for attributes defined in draft-behera-ldap-password-policy

$Id: ppolicy.py,v 1.4 2008/02/20 12:05:41 michael Exp $
"""

import pyweblib.forms

from w2lapp.core import utf2display

from w2lapp.schema.syntaxes import LDAPSyntax,Boolean,Integer,IA5String,SelectList,DynamicDNSelectList,syntax_registry


class PwdCheckQuality(SelectList):
  oid = 'PwdCheckQuality-oid'
  desc = ''

  attr_value_dict = {
    '':'',
    '0':'quality checking not be enforced',
    '1':'quality checking enforced, accepting un-checkable passwords',
    '2':'quality checking always enforced',
  }


class PwdPolicySubentry(DynamicDNSelectList):
  oid = 'PwdPolicySubentry-oid'
  desc = 'DN of the pwdPolicy entry to be used for a certain entry'
  ldap_url = 'ldap:///.?entryDN?sub?(objectClass=pwdPolicy)'

syntax_registry.registerAttrType(
  PwdPolicySubentry.oid,[
    '1.3.6.1.4.1.42.2.27.8.1.23', # pwdPolicySubentry
  ]
)


syntax_registry.registerAttrType(
  PwdCheckQuality.oid,[
    '1.3.6.1.4.1.42.2.27.8.1.5', # pwdCheckQuality (see draft-behera-ldap-password-policy)
  ]
)

# Register all syntax classes in this module
for name in dir():
  syntax_registry.registerSyntaxClass(eval(name))

